## hipify 6.0.2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16.8)

project(hipify-clang)

include(GNUInstallDirs)

option(HIPIFY_CLANG_TESTS "Build HIPIFY tests, if lit is installed" OFF)
option(HIPIFY_CLANG_TESTS_ONLY "Build HIPIFY tests only, if lit is installed and hipify-clang binary is already produced" OFF)
option(HIPIFY_INCLUDE_IN_HIP_SDK "Include HIPIFY in HIP SDK" OFF)

if(HIPIFY_CLANG_TESTS OR HIPIFY_CLANG_TESTS_ONLY)
  set(HIPIFY_TEST "ON")
else()
  set(HIPIFY_TEST "OFF")
endif()

if(HIPIFY_CLANG_TESTS_ONLY)
  set(HIPIFY_BUILD "OFF")
else()
  set(HIPIFY_BUILD "ON")
endif()

message(STATUS "HIPIFY config:")
message(STATUS "   - Build hipify-clang : ${HIPIFY_BUILD}")
message(STATUS "   - Test  hipify-clang : ${HIPIFY_TEST}")
message(STATUS "   - Is part of HIP SDK : ${HIPIFY_INCLUDE_IN_HIP_SDK}")

if(HIPIFY_INCLUDE_IN_HIP_SDK)
  if(NOT WIN32)
    message(FATAL_ERROR "HIPIFY_INCLUDE_IN_HIP_SDK is only supported on Windows")
  elseif(CMAKE_GENERATOR MATCHES "Visual Studio")
    message(FATAL_ERROR "HIPIFY_INCLUDE_IN_HIP_SDK is not targeting Visual Studio")
  endif()
else()
  find_package(Clang REQUIRED CONFIG PATHS ${CMAKE_PREFIX_PATH})
  find_package(LLVM REQUIRED CONFIG PATHS ${CMAKE_PREFIX_PATH})

  message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}:")
  message(STATUS "   - CMake module path  : ${LLVM_CMAKE_DIR}")
  message(STATUS "   - Clang include path : ${CLANG_INCLUDE_DIRS}")
  message(STATUS "   - LLVM Include path  : ${LLVM_INCLUDE_DIRS}")
  message(STATUS "   - Binary path        : ${LLVM_TOOLS_BINARY_DIR}")
endif()

list(APPEND CMAKE_MODULE_PATH ${LLVM_CMAKE_DIR})
include(AddLLVM)

if (NOT HIPIFY_CLANG_TESTS_ONLY)
  if(MSVC AND MSVC_VERSION VERSION_LESS "1900")
    message(SEND_ERROR "hipify-clang could be built by Visual Studio 14 2015 or higher.")
    return()
  endif()

  include_directories(${CLANG_INCLUDE_DIRS})
  include_directories(${LLVM_INCLUDE_DIRS})
  add_definitions(${LLVM_DEFINITIONS})

  file(GLOB_RECURSE HIPIFY_SOURCES src/*.cpp)
  file(GLOB_RECURSE HIPIFY_HEADERS src/*.h)

  add_llvm_executable(hipify-clang ${HIPIFY_SOURCES} ${HIPIFY_HEADERS})
  target_link_directories(hipify-clang PRIVATE ${LLVM_LIBRARY_DIRS})

  if(HIPIFY_INCLUDE_IN_HIP_SDK)
    if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
      message(FATAL_ERROR "In order to include HIPIFY in HIP SDK, HIPIFY needs to be built with LLVM_EXTERNAL_PROJECTS")
    endif()

    # Need to add clang include directories explicitly if building as part of llvm.
    if(LLVM_EXTERNAL_CLANG_SOURCE_DIR)
      target_include_directories(hipify-clang
        PRIVATE
          ${LLVM_BINARY_DIR}/tools/clang/include
          ${LLVM_EXTERNAL_CLANG_SOURCE_DIR}/include)
    endif()

    # Need to add lld include directories explicitly if building as part of llvm.
    if(LLVM_EXTERNAL_LLD_SOURCE_DIR)
      target_include_directories(hipify-clang
        PRIVATE
          ${LLVM_BINARY_DIR}/tools/lld/include
          ${LLVM_EXTERNAL_LLD_SOURCE_DIR}/include)
    endif()
  else()
    set(CMAKE_CXX_COMPILER ${LLVM_TOOLS_BINARY_DIR}/clang++)
    set(CMAKE_C_COMPILER ${LLVM_TOOLS_BINARY_DIR}/clang)
  endif()

  # Link against LLVM and CLANG libraries.
  target_link_libraries(hipify-clang PRIVATE
    clangASTMatchers
    clangFrontend
    clangTooling
    clangParse
    clangSerialization
    clangSema
    clangEdit
    clangFormat
    clangLex
    clangAnalysis
    clangDriver
    clangAST
    clangToolingCore
    clangRewrite
    clangBasic
    LLVMProfileData
    LLVMSupport
    LLVMMCParser
    LLVMMC
    LLVMBitReader
    LLVMOption
    LLVMCore)

  if(LLVM_PACKAGE_VERSION VERSION_GREATER "6.0.1")
    target_link_libraries(hipify-clang PRIVATE clangToolingInclusions)
  endif()

  if(LLVM_PACKAGE_VERSION VERSION_GREATER "9.0.1")
    target_link_libraries(hipify-clang PRIVATE LLVMFrontendOpenMP)
  endif()

  if(LLVM_PACKAGE_VERSION VERSION_EQUAL "15.0.0" OR LLVM_PACKAGE_VERSION VERSION_GREATER "15.0.0")
    target_link_libraries(hipify-clang PRIVATE LLVMWindowsDriver clangSupport)
  endif()

  if(LLVM_PACKAGE_VERSION VERSION_EQUAL "16.0.0" OR LLVM_PACKAGE_VERSION VERSION_GREATER "16.0.0")
    if(MSVC)
      set(STD "/std:c++17")
    else()
      set(STD "-std=c++17")
    endif()
  else()
    if(MSVC)
      set(STD "/std:c++14")
    else()
      set(STD "-std=c++14")
    endif()
  endif()

  if(MSVC)
    target_link_libraries(hipify-clang PRIVATE version)
    target_compile_options(hipify-clang PRIVATE ${STD} /Od /GR- /EHs- /EHc-)
    if((LLVM_PACKAGE_VERSION VERSION_EQUAL "18.0.0" OR LLVM_PACKAGE_VERSION VERSION_GREATER "18.0.0") AND MSVC_VERSION VERSION_GREATER "1919")
      target_compile_options(hipify-clang PRIVATE /Zc:preprocessor)
    endif()
    set(CMAKE_CXX_LINK_FLAGS "${CMAKE_CXX_LINK_FLAGS} /SUBSYSTEM:WINDOWS")
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${STD} -pthread -fno-rtti -fvisibility-inlines-hidden")
  endif()

  # Address Sanitize Flag.
  if(ADDRESS_SANITIZER)
    set(addr_var -fsanitize=address)
  else()
    set(addr_var )
  endif()
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_CFLAGS} ${addr_var}")

  if(LLVM_PACKAGE_VERSION VERSION_EQUAL "16.0.0" OR LLVM_PACKAGE_VERSION VERSION_GREATER "16.0.0")
    set(LIB_CLANG_RES ${LLVM_VERSION_MAJOR})
  else()
    set(LIB_CLANG_RES ${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH})
  endif()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CFLAGS} -DHIPIFY_CLANG_RES=\\\"${LLVM_LIBRARY_DIRS}/clang/${LIB_CLANG_RES}\\\" ${addr_var}")

  set(INSTALL_PATH_DOC_STRING "hipify-clang Installation Path")
  if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}/dist" CACHE PATH ${INSTALL_PATH_DOC_STRING} FORCE)
  endif()

  set(HIPIFY_BIN_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/bin")

  install(TARGETS hipify-clang DESTINATION bin)
  # Install bin directory in CMAKE_INSTALL_PREFIX path.
  install(
    DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/bin
    DESTINATION .
    USE_SOURCE_PERMISSIONS
    PATTERN "hipify-perl"
    PATTERN "*.sh")

  # Headers are already included in HIP SDK, so skip those if including HIPIFY in HIP SDK.
  if(NOT HIPIFY_INCLUDE_IN_HIP_SDK)
    # Install all folders under clang/version/ in CMAKE_INSTALL_PREFIX path.
    install(
      DIRECTORY ${LLVM_DIR}/../../clang/${LIB_CLANG_RES}/
      DESTINATION .
      COMPONENT clang-resource-headers
      FILES_MATCHING
      PATTERN "*.h"
      PATTERN "*.modulemap"
      PATTERN "algorithm"
      PATTERN "complex"
      PATTERN "new"
      PATTERN "ppc_wrappers" EXCLUDE
      PATTERN "openmp_wrappers" EXCLUDE)
  endif()

# install all folders under clang/version/ in CMAKE_INSTALL_PREFIX path
install(
    DIRECTORY ${LLVM_DIR}/../../clang/${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH}/
    DESTINATION .
    COMPONENT clang-resource-headers
    FILES_MATCHING
    PATTERN "*.h"
    PATTERN "*.modulemap"
    PATTERN "algorithm"
    PATTERN "complex"
    PATTERN "new"
    PATTERN "ppc_wrappers" EXCLUDE
    PATTERN "openmp_wrappers" EXCLUDE)

  if(UNIX)
    # Get rid of any RPATH definations already.
    set_target_properties(hipify-clang PROPERTIES INSTALL_RPATH "")
    # Set RPATH for the binary.
    set_target_properties(hipify-clang PROPERTIES LINK_FLAGS "-Wl,--enable-new-dtags -Wl,--rpath,$ORIGIN/../lib" )

    option(FILE_REORG_BACKWARD_COMPATIBILITY "Enable File Reorg with backward compatibility" OFF)

    if(FILE_REORG_BACKWARD_COMPATIBILITY)
      include(hipify-backward-compat.cmake)
    endif()

    set(CPACK_PACKAGING_INSTALL_PREFIX "/opt/rocm" CACHE PATH "HIP Package Installation Path")
    set(BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR}/packages/hipify-clang)

    configure_file(packaging/hipify-clang.txt ${BUILD_DIR}/CMakeLists.txt @ONLY)
    configure_file(${CMAKE_SOURCE_DIR}/LICENSE.txt ${BUILD_DIR}/LICENSE.txt @ONLY)

    add_custom_target(package_hipify-clang COMMAND ${CMAKE_COMMAND} .
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
      COMMAND rm -rf *.deb *.rpm *.tar.gz
      COMMAND make package
      COMMAND cp *.deb ${PROJECT_BINARY_DIR}
      COMMAND cp *.rpm ${PROJECT_BINARY_DIR}
      COMMAND cp *.tar.gz ${PROJECT_BINARY_DIR}
      WORKING_DIRECTORY ${BUILD_DIR})
  endif()

endif() # if (NOT HIPIFY_CLANG_TESTS_ONLY)

if(HIPIFY_CLANG_TESTS OR HIPIFY_CLANG_TESTS_ONLY)

  message(STATUS "---- The below configuring for hipify-clang testing only ----")

  if(${CMAKE_VERSION} VERSION_LESS "3.27.0")
    find_package(PythonInterp 2.7 REQUIRED)
  else()
    find_package(Python 2.7...3.12 REQUIRED)
  endif()

  function (require_program PROGRAM_NAME)
    find_program(FOUND_${PROGRAM_NAME} ${PROGRAM_NAME})
    if(FOUND_${PROGRAM_NAME})
       message(STATUS "Found ${PROGRAM_NAME}: ${FOUND_${PROGRAM_NAME}}")
    else()
       message(SEND_ERROR "Can't find ${PROGRAM_NAME}. Either set HIPIFY_CLANG_TESTS(_ONLY) to OFF to disable HIPIFY tests, or install the missing program.")
    endif()
  endfunction()

  require_program(lit)
  require_program(FileCheck)

  set(CUDA_TOOLKIT_ROOT_DIR OFF CACHE PATH "Path to CUDA Toolkit to use in hipify-clang unit testing")
  set(CUDA_SDK_ROOT_DIR OFF CACHE PATH "Path to CUDA Toolkit Samples")
  set(CUDA_DNN_ROOT_DIR OFF CACHE PATH "Path to cuDNN")
  set(CUDA_CUB_ROOT_DIR OFF CACHE PATH "Path to CUB")

  if(DEFINED CUDA_TOOLKIT_ROOT_DIR AND NOT CUDA_TOOLKIT_ROOT_DIR MATCHES "OFF")
    if(NOT DEFINED CUDAToolkit_ROOT OR CUDAToolkit_ROOT MATCHES "OFF")
      set(CUDAToolkit_ROOT "${CUDA_TOOLKIT_ROOT_DIR}")
    endif()
  else()
    if(DEFINED CUDAToolkit_ROOT AND NOT CUDAToolkit_ROOT MATCHES "OFF")
      set(CUDA_TOOLKIT_ROOT_DIR "${CUDAToolkit_ROOT}")
    endif()
  endif()

  message(STATUS "Initial CUDA to configure:")
  message(STATUS "   - CUDA Toolkit path  : ${CUDA_TOOLKIT_ROOT_DIR}")
  message(STATUS "   - CUDA Samples path  : ${CUDA_SDK_ROOT_DIR}")
  message(STATUS "   - cuDNN path         : ${CUDA_DNN_ROOT_DIR}")
  message(STATUS "   - CUB path           : ${CUDA_CUB_ROOT_DIR}")

  if(${CMAKE_VERSION} VERSION_LESS "3.27.0")
    find_package(CUDA REQUIRED)
    set(CUDA_VERSION_FULL     "${CUDA_VERSION}")
  else()
    find_package(CUDAToolkit REQUIRED)
    set(CUDA_VERSION_MAJOR    "${CUDAToolkit_VERSION_MAJOR}")
    set(CUDA_VERSION_MINOR    "${CUDAToolkit_VERSION_MINOR}")
    set(CUDA_VERSION_PATCH    "${CUDAToolkit_VERSION_PATCH}")
    set(CUDA_VERSION_FULL     "${CUDAToolkit_VERSION}")
    set(CUDA_VERSION          "${CUDAToolkit_VERSION_MAJOR}.${CUDAToolkit_VERSION_MINOR}")
    set(CUDA_TOOLKIT_ROOT_DIR "${CUDAToolkit_LIBRARY_ROOT}")
  endif()

  if(WIN32 AND CUDA_VERSION VERSION_LESS "11.6" AND CUDA_SDK_ROOT_DIR STREQUAL "OFF" AND NOT CUDA_TOOLKIT_ROOT_DIR MATCHES "OFF")
    set(NVCUDASAMPLES "NVCUDASAMPLES${CUDA_VERSION_MAJOR}_${CUDA_VERSION_MINOR}_ROOT")
    if(DEFINED ENV{${NVCUDASAMPLES}})
      set(CUDA_SDK_ROOT_DIR "$ENV{${NVCUDASAMPLES}}")
      string(REPLACE "\\" "/" CUDA_SDK_ROOT_DIR ${CUDA_SDK_ROOT_DIR})
    endif()
  endif()

  message(STATUS "Found CUDA config:")
  message(STATUS "   - CUDA Toolkit path  : ${CUDA_TOOLKIT_ROOT_DIR}")
  message(STATUS "   - CUDA Samples path  : ${CUDA_SDK_ROOT_DIR}")
  message(STATUS "   - cuDNN path         : ${CUDA_DNN_ROOT_DIR}")
  message(STATUS "   - CUB path           : ${CUDA_CUB_ROOT_DIR}")

  if((CUDA_VERSION VERSION_LESS "7.0") OR (LLVM_PACKAGE_VERSION VERSION_LESS "3.8") OR
     (CUDA_VERSION VERSION_GREATER "7.5" AND LLVM_PACKAGE_VERSION VERSION_LESS "4.0") OR
     (CUDA_VERSION VERSION_GREATER "8.0" AND LLVM_PACKAGE_VERSION VERSION_LESS "6.0") OR
     (CUDA_VERSION VERSION_GREATER "9.0" AND LLVM_PACKAGE_VERSION VERSION_LESS "7.0") OR
     (CUDA_VERSION VERSION_GREATER "9.2" AND LLVM_PACKAGE_VERSION VERSION_LESS "8.0") OR
     (CUDA_VERSION VERSION_GREATER "10.0" AND LLVM_PACKAGE_VERSION VERSION_LESS "9.0") OR
     (CUDA_VERSION VERSION_GREATER "10.1" AND LLVM_PACKAGE_VERSION VERSION_LESS "10.0"))
    message(SEND_ERROR "CUDA ${CUDA_VERSION} is not supported by LLVM ${LLVM_PACKAGE_VERSION}.")

=== docs/.sphinx/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.8
# by the following command:
#
#    pip-compile requirements.in
#
accessible-pygments==0.0.3
    # via pydata-sphinx-theme
alabaster==0.7.13
    # via sphinx
babel==2.12.1
    # via
    #   pydata-sphinx-theme
    #   sphinx
beautifulsoup4==4.11.2
    # via pydata-sphinx-theme
breathe==4.34.0
    # via rocm-docs-core
certifi==2022.12.7
    # via requests
cffi==1.15.1
    # via
    #   cryptography
    #   pynacl
charset-normalizer==3.1.0
    # via requests
click==8.1.3
    # via sphinx-external-toc
cryptography==40.0.2
    # via pyjwt
deprecated==1.2.13
    # via pygithub
docutils==0.19
    # via
    #   breathe
    #   myst-parser
    #   pydata-sphinx-theme
    #   sphinx
fastjsonschema==2.16.3
    # via rocm-docs-core
gitdb==4.0.10
    # via gitpython
gitpython==3.1.31
    # via rocm-docs-core
idna==3.4
    # via requests
imagesize==1.4.1
    # via sphinx
jinja2==3.1.2
    # via
    #   myst-parser
    #   sphinx
markdown-it-py==2.2.0
    # via
    #   mdit-py-plugins
    #   myst-parser
markupsafe==2.1.2
    # via jinja2
mdit-py-plugins==0.3.5
    # via myst-parser
mdurl==0.1.2
    # via markdown-it-py
myst-parser==1.0.0
    # via rocm-docs-core
packaging==23.0
    # via
    #   pydata-sphinx-theme
    #   sphinx
pycparser==2.21
    # via cffi
pydata-sphinx-theme==0.13.3
    # via
    #   rocm-docs-core
    #   sphinx-book-theme
pygithub==1.58.1
    # via rocm-docs-core
pygments==2.14.0
    # via
    #   accessible-pygments
    #   pydata-sphinx-theme
    #   sphinx
pyjwt[crypto]==2.6.0
    # via pygithub
pynacl==1.5.0
    # via pygithub
pyyaml==6.0
    # via
    #   myst-parser
    #   rocm-docs-core
    #   sphinx-external-toc
requests==2.28.2
    # via
    #   pygithub
    #   sphinx
rocm-docs-core==0.26.0
    # via -r requirements.in
smmap==5.0.0
    # via gitdb
snowballstemmer==2.2.0
    # via sphinx
soupsieve==2.4
    # via beautifulsoup4
sphinx==5.3.0
    # via
    #   breathe
    #   myst-parser
    #   pydata-sphinx-theme
    #   rocm-docs-core
    #   sphinx-book-theme
    #   sphinx-copybutton
    #   sphinx-design
    #   sphinx-external-toc
    #   sphinx-notfound-page
sphinx-book-theme==1.0.1
    # via rocm-docs-core
sphinx-copybutton==0.5.1
    # via rocm-docs-core
sphinx-design==0.4.1
    # via rocm-docs-core
sphinx-external-toc==0.3.1
    # via rocm-docs-core
sphinx-notfound-page==0.8.3
    # via rocm-docs-core
sphinxcontrib-applehelp==1.0.4
    # via sphinx
sphinxcontrib-devhelp==1.0.2
    # via sphinx
sphinxcontrib-htmlhelp==2.0.1
    # via sphinx
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-qthelp==1.0.3
    # via sphinx
sphinxcontrib-serializinghtml==1.1.5
    # via sphinx
typing-extensions==4.5.0
    # via pydata-sphinx-theme
urllib3==1.26.15
    # via requests
wrapt==1.15.0
    # via deprecated

=== debian/changelog ===
hipify (6.0.2+dfsg-1) unstable; urgency=medium

  * Migrate to unstable
  * hipify-clang now recommends nvidia-cuda-toolkit

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 22 Apr 2024 03:07:17 -0600

hipify (6.0.2+dfsg-1~exp1) experimental; urgency=medium

  * Initial release. (Closes: #1063741)

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 11 Feb 2024 23:17:57 -0700

=== debian/control ===
Source: hipify
Section: devel
Homepage: https://github.com/ROCm/HIPIFY
Priority: optional
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rocm-team/hipify.git
Vcs-Browser: https://salsa.debian.org/rocm-team/hipify
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Cordell Bloor <cgmb@slerp.xyz>
Build-Depends:
 debhelper-compat (= 13),
 clang-17,
 cmake,
 libclang-17-dev,
 libzstd-dev,
 llvm-17-dev,
 zlib1g-dev,
Rules-Requires-Root: no

Package: hipify-clang
Section: contrib/devel
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
Recommends: nvidia-cuda-toolkit
Description: CUDA to HIP source-to-source translation tool
 hipify-clang is a tool that converts CUDA sources to HIP. It is built on
 libclang and operates on an abstract syntax tree. It can therefore translate
 code containing complex C++ constructs, but it requires input sources to be
 fully compilable.

Package: hipify-perl
Architecture: all
Depends: ${perl:Depends},
         ${misc:Depends},
Description: simple CUDA to HIP source-to-source translation tool
 hipify-perl is a simple tool that processes CUDA sources and converts them to
 HIP sources using textual replacements. It uses a simple perl parser and can
 therefore translate syntactically invalid inputs and source file fragments, but
 it may not recognize constructs that would require more context to correctly
 convert, such as macro expansions or namespace usage.

=== debian/rules ===
#!/usr/bin/make -f
export VERBOSE=1

%:
	dh $@ -Scmake

# dwz does not support DWARF-5
override_dh_dwz:
	:

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg//,oversionmangle=s/(.*)/$1+dfsg/,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hipify-$1.tar.gz%" \
    https://github.com/rocm/hipify/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian

## hipify 6.4.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,11 @@
 option(HIPIFY_CLANG_TESTS "Build HIPIFY tests, if lit is installed" OFF)
 option(HIPIFY_CLANG_TESTS_ONLY "Build HIPIFY tests only, if lit is installed and hipify-clang binary is already produced" OFF)
 option(HIPIFY_INCLUDE_IN_HIP_SDK "Include HIPIFY in HIP SDK" OFF)
+option(HIPIFY_INSTALL_CLANG_HEADERS "Include clang headers in HIPIFY installation" ON)
+
+if(NOT WIN32)
+  set(CPACK_SET_DESTDIR ON CACHE BOOL "Installer package will install hipify to CMAKE_INSTALL_PREFIX instead of CPACK_PACKAGING_INSTALL_PREFIX")
+endif()
 
 if(HIPIFY_CLANG_TESTS OR HIPIFY_CLANG_TESTS_ONLY)
   set(HIPIFY_TEST "ON")
@@ -21,9 +26,10 @@
 endif()
 
 message(STATUS "HIPIFY config:")
-message(STATUS "   - Build hipify-clang : ${HIPIFY_BUILD}")
-message(STATUS "   - Test  hipify-clang : ${HIPIFY_TEST}")
-message(STATUS "   - Is part of HIP SDK : ${HIPIFY_INCLUDE_IN_HIP_SDK}")
+message(STATUS "   - Build hipify-clang    : ${HIPIFY_BUILD}")
+message(STATUS "   - Test hipify-clang     : ${HIPIFY_TEST}")
+message(STATUS "   - Is part of HIP SDK    : ${HIPIFY_INCLUDE_IN_HIP_SDK}")
+message(STATUS "   - Install clang headers : ${HIPIFY_INSTALL_CLANG_HEADERS}")
 
 if(HIPIFY_INCLUDE_IN_HIP_SDK)
   if(NOT WIN32)
@@ -36,10 +42,10 @@
   find_package(LLVM REQUIRED CONFIG PATHS ${CMAKE_PREFIX_PATH})
 
   message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}:")
-  message(STATUS "   - CMake module path  : ${LLVM_CMAKE_DIR}")
-  message(STATUS "   - Clang include path : ${CLANG_INCLUDE_DIRS}")
-  message(STATUS "   - LLVM Include path  : ${LLVM_INCLUDE_DIRS}")
-  message(STATUS "   - Binary path        : ${LLVM_TOOLS_BINARY_DIR}")
+  message(STATUS "   - CMake module path     : ${LLVM_CMAKE_DIR}")
+  message(STATUS "   - Clang include path    : ${CLANG_INCLUDE_DIRS}")
+  message(STATUS "   - LLVM Include path     : ${LLVM_INCLUDE_DIRS}")
+  message(STATUS "   - Binary path           : ${LLVM_TOOLS_BINARY_DIR}")
 endif()
 
 list(APPEND CMAKE_MODULE_PATH ${LLVM_CMAKE_DIR})
@@ -139,7 +145,7 @@
 
   if(MSVC)
     target_link_libraries(hipify-clang PRIVATE version)
-    target_compile_options(hipify-clang PRIVATE ${STD} /Od /GR- /EHs- /EHc-)
+    target_compile_options(hipify-clang PRIVATE ${STD} /Od /GR- /EHs- /EHc- /MP)
     if((LLVM_PACKAGE_VERSION VERSION_EQUAL "18.0.0" OR LLVM_PACKAGE_VERSION VERSION_GREATER "18.0.0") AND MSVC_VERSION VERSION_GREATER "1919")
       target_compile_options(hipify-clang PRIVATE /Zc:preprocessor)
     endif()
@@ -161,7 +167,7 @@
   else()
     set(LIB_CLANG_RES ${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH})
   endif()
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CFLAGS} -DHIPIFY_CLANG_RES=\\\"${LLVM_LIBRARY_DIRS}/clang/${LIB_CLANG_RES}\\\" ${addr_var}")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CFLAGS} -DLIB_CLANG_RES=${LIB_CLANG_RES} ${addr_var}")
 
   set(INSTALL_PATH_DOC_STRING "hipify-clang Installation Path")
   if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
@@ -175,25 +181,44 @@
   install(
     DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/bin
     DESTINATION .
-    USE_SOURCE_PERMISSIONS
     PATTERN "hipify-perl"
-    PATTERN "*.sh")
+    PATTERN "*.sh"
+    PATTERN "findcode.sh" EXCLUDE
+    PATTERN "findcode_headers.sh" EXCLUDE
+    PATTERN "findcode_sources.sh" EXCLUDE
+    PATTERN "findcode_custom.sh" EXCLUDE
+    PATTERN "finduncodep.sh" EXCLUDE)
+
+  set(HIPIFY_LIBEXEC_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}/hipify")
+
+  install(
+    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/findcode.sh
+    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/findcode_headers.sh
+    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/findcode_sources.sh
+    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/findcode_custom.sh
+    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/finduncodep.sh
+    DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/hipify)
 
   # Headers are already included in HIP SDK, so skip those if including HIPIFY in HIP SDK.
-  if(NOT HIPIFY_INCLUDE_IN_HIP_SDK)
-    # Install all folders under clang/version/ in CMAKE_INSTALL_PREFIX path.
-    install(
-      DIRECTORY ${LLVM_DIR}/../../clang/${LIB_CLANG_RES}/
-      DESTINATION .
-      COMPONENT clang-resource-headers
-      FILES_MATCHING
-      PATTERN "*.h"
-      PATTERN "*.modulemap"
-      PATTERN "algorithm"
-      PATTERN "complex"
-      PATTERN "new"
-      PATTERN "ppc_wrappers" EXCLUDE
-      PATTERN "openmp_wrappers" EXCLUDE)
+  if( HIPIFY_INSTALL_CLANG_HEADERS)
+    if(NOT HIPIFY_INCLUDE_IN_HIP_SDK)
+      # Install all folders under clang/version/ in CMAKE_INSTALL_PREFIX path.
+      install(
+        DIRECTORY ${LLVM_LIBRARY_DIRS}/clang/${LIB_CLANG_RES}/include/
+        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/hipify/${CMAKE_INSTALL_INCLUDEDIR}
+        COMPONENT clang-resource-headers
+        FILES_MATCHING
+        PATTERN "*.h"
+        PATTERN "*.modulemap"
+        PATTERN "algorithm"
+        PATTERN "complex"
+        PATTERN "new"
+        PATTERN "ppc_wrappers" EXCLUDE
+        PATTERN "omp-tools.h" EXCLUDE
+        PATTERN "omp.h" EXCLUDE
+        PATTERN "ompt.h" EXCLUDE
+        PATTERN "openmp_wrappers" EXCLUDE)
+    endif()
   endif()
 
 # install all folders under clang/version/ in CMAKE_INSTALL_PREFIX path
@@ -244,10 +269,12 @@
 
   message(STATUS "---- The below configuring for hipify-clang testing only ----")
 
+  set (HIPIFY_CLANG_RES "${LLVM_LIBRARY_DIRS}/clang/${LIB_CLANG_RES}")
+
   if(${CMAKE_VERSION} VERSION_LESS "3.27.0")
-    find_package(PythonInterp 2.7 REQUIRED)
-  else()
-    find_package(Python 2.7...3.12 REQUIRED)
+    find_package(PythonInterp 3.0 REQUIRED)
+  else()
+    find_package(Python 3.0...3.14 REQUIRED)
   endif()
 
   function (require_program PROGRAM_NAME)
@@ -262,12 +289,13 @@
   require_program(lit)
   require_program(FileCheck)
 
-  set(CUDA_TOOLKIT_ROOT_DIR OFF CACHE PATH "Path to CUDA Toolkit to use in hipify-clang unit testing")
-  set(CUDA_SDK_ROOT_DIR OFF CACHE PATH "Path to CUDA Toolkit Samples")
-  set(CUDA_DNN_ROOT_DIR OFF CACHE PATH "Path to cuDNN")
-  set(CUDA_CUB_ROOT_DIR OFF CACHE PATH "Path to CUB")
-
-  if(DEFINED CUDA_TOOLKIT_ROOT_DIR AND NOT CUDA_TOOLKIT_ROOT_DIR MATCHES "OFF")
+  set(CUDA_TOOLKIT_ROOT_DIR "" CACHE PATH "Path to CUDA Toolkit to use in hipify-clang unit testing")
+  set(CUDA_SDK_ROOT_DIR     "" CACHE PATH "Path to CUDA Toolkit Samples")
+  set(CUDA_DNN_ROOT_DIR     "" CACHE PATH "Path to cuDNN")
+  set(CUDA_TENSOR_ROOT_DIR  "" CACHE PATH "Path to cuTENSOR")
+  set(CUDA_CUB_ROOT_DIR     "" CACHE PATH "Path to CUB")
+
+  if(NOT CUDA_TOOLKIT_ROOT_DIR STREQUAL "" AND NOT CUDA_TOOLKIT_ROOT_DIR MATCHES "OFF")
     if(NOT DEFINED CUDAToolkit_ROOT OR CUDAToolkit_ROOT MATCHES "OFF")
       set(CUDAToolkit_ROOT "${CUDA_TOOLKIT_ROOT_DIR}")
     endif()
@@ -278,10 +306,11 @@
   endif()
 
   message(STATUS "Initial CUDA to configure:")
-  message(STATUS "   - CUDA Toolkit path  : ${CUDA_TOOLKIT_ROOT_DIR}")
-  message(STATUS "   - CUDA Samples path  : ${CUDA_SDK_ROOT_DIR}")
-  message(STATUS "   - cuDNN path         : ${CUDA_DNN_ROOT_DIR}")
-  message(STATUS "   - CUB path           : ${CUDA_CUB_ROOT_DIR}")
+  message(STATUS "   - CUDA Toolkit path     : ${CUDA_TOOLKIT_ROOT_DIR}")
+  message(STATUS "   - CUDA Samples path     : ${CUDA_SDK_ROOT_DIR}")
+  message(STATUS "   - cuDNN path            : ${CUDA_DNN_ROOT_DIR}")
+  message(STATUS "   - cuTENSOR path         : ${CUDA_TENSOR_ROOT_DIR}")
+  message(STATUS "   - CUB path              : ${CUDA_CUB_ROOT_DIR}")
 
   if(${CMAKE_VERSION} VERSION_LESS "3.27.0")
     find_package(CUDA REQUIRED)
@@ -296,25 +325,3 @@
     set(CUDA_TOOLKIT_ROOT_DIR "${CUDAToolkit_LIBRARY_ROOT}")
   endif()
 
-  if(WIN32 AND CUDA_VERSION VERSION_LESS "11.6" AND CUDA_SDK_ROOT_DIR STREQUAL "OFF" AND NOT CUDA_TOOLKIT_ROOT_DIR MATCHES "OFF")
-    set(NVCUDASAMPLES "NVCUDASAMPLES${CUDA_VERSION_MAJOR}_${CUDA_VERSION_MINOR}_ROOT")
-    if(DEFINED ENV{${NVCUDASAMPLES}})
-      set(CUDA_SDK_ROOT_DIR "$ENV{${NVCUDASAMPLES}}")
-      string(REPLACE "\\" "/" CUDA_SDK_ROOT_DIR ${CUDA_SDK_ROOT_DIR})
-    endif()
-  endif()
-
-  message(STATUS "Found CUDA config:")
-  message(STATUS "   - CUDA Toolkit path  : ${CUDA_TOOLKIT_ROOT_DIR}")
-  message(STATUS "   - CUDA Samples path  : ${CUDA_SDK_ROOT_DIR}")
-  message(STATUS "   - cuDNN path         : ${CUDA_DNN_ROOT_DIR}")
-  message(STATUS "   - CUB path           : ${CUDA_CUB_ROOT_DIR}")
-
-  if((CUDA_VERSION VERSION_LESS "7.0") OR (LLVM_PACKAGE_VERSION VERSION_LESS "3.8") OR
-     (CUDA_VERSION VERSION_GREATER "7.5" AND LLVM_PACKAGE_VERSION VERSION_LESS "4.0") OR
-     (CUDA_VERSION VERSION_GREATER "8.0" AND LLVM_PACKAGE_VERSION VERSION_LESS "6.0") OR
-     (CUDA_VERSION VERSION_GREATER "9.0" AND LLVM_PACKAGE_VERSION VERSION_LESS "7.0") OR
-     (CUDA_VERSION VERSION_GREATER "9.2" AND LLVM_PACKAGE_VERSION VERSION_LESS "8.0") OR
-     (CUDA_VERSION VERSION_GREATER "10.0" AND LLVM_PACKAGE_VERSION VERSION_LESS "9.0") OR
-     (CUDA_VERSION VERSION_GREATER "10.1" AND LLVM_PACKAGE_VERSION VERSION_LESS "10.0"))
-    message(SEND_ERROR "CUDA ${CUDA_VERSION} is not supported by LLVM ${LLVM_PACKAGE_VERSION}.")

=== debian/changelog ===
hipify (6.4.3+dfsg-1~exp1) experimental; urgency=medium

  [ Kentaro Hayashi ]
  * Use d/watch 5

  [ Igor Luppi ]
  * New upstream version 6.4.3+dfsg
  * Update build-deps from LLVM 17 to LLVM 20 (Closes: #1084069)
  * Update link libraries for LLVM 20
  * Omit find-shell scripts from installation

  [ Cordell Bloor ]
  * Update my email address
  * Enable hardening flags
  * Update standards version to 4.7.2. No changes required.
  * Set hipify-perl interpreter to /usr/bin/perl
  * Add d/p/use-system-clang-resource-directory.patch to ensure
    hipify-clang can find the LLVM 20 resource directory
  * Add d/gbp.conf with the package defaults for pristine-tar
    and patch numbering
  * Verify 6.4.3+dfsg builds with GCC-15 (Closes: #1096810)

 -- Cordell Bloor <cgmb@debian.org>  Wed, 10 Sep 2025 19:12:29 -0600

=== debian/control ===
--- 
+++ 
@@ -2,18 +2,18 @@
 Section: devel
 Homepage: https://github.com/ROCm/HIPIFY
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/rocm-team/hipify.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/hipify
 Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
-Uploaders: Cordell Bloor <cgmb@slerp.xyz>
+Uploaders: Cordell Bloor <cgmb@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- clang-17,
+ clang-20,
  cmake,
- libclang-17-dev,
+ libclang-20-dev,
  libzstd-dev,
- llvm-17-dev,
+ llvm-20-dev,
  zlib1g-dev,
 Rules-Requires-Root: no

## hipify 7.0.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -64,7 +64,37 @@
   file(GLOB_RECURSE HIPIFY_SOURCES src/*.cpp)
   file(GLOB_RECURSE HIPIFY_HEADERS src/*.h)
 
-  add_llvm_executable(hipify-clang ${HIPIFY_SOURCES} ${HIPIFY_HEADERS})
+  # In order to be compatible with an LLVM that uses LLVM_LINK_LLVM_DYLIB=ON,
+  # hipify-clang must link core LLVM libraries via LLVM_LINK_COMPONENTS vs directly adding
+  # them.
+  set(HIPIFY_ADDL_LINK_LIBS)
+  set(LLVM_LINK_COMPONENTS
+    ProfileData
+    Support
+    MCParser
+    MC
+    BitReader
+    Option
+    Core
+  )
+  
+  if(LLVM_PACKAGE_VERSION VERSION_GREATER "6.0.1")
+    list(APPEND HIPIFY_ADDL_LINK_LIBS clangToolingInclusions)
+  endif()
+
+  if(LLVM_PACKAGE_VERSION VERSION_GREATER "9.0.1")
+    list(APPEND LLVM_LINK_COMPONENTS FrontendOpenMP)
+  endif()
+
+  if(LLVM_PACKAGE_VERSION VERSION_EQUAL "15.0.0" OR LLVM_PACKAGE_VERSION VERSION_GREATER "15.0.0")
+    list(APPEND LLVM_LINK_COMPONENTS WindowsDriver)
+    list(APPEND HIPIFY_ADDL_LINK_LIBS clangSupport)
+  endif()
+
+
+  add_llvm_executable(hipify-clang
+    ${HIPIFY_SOURCES} ${HIPIFY_HEADERS}
+  )
   target_link_directories(hipify-clang PRIVATE ${LLVM_LIBRARY_DIRS})
 
   if(HIPIFY_INCLUDE_IN_HIP_SDK)
@@ -87,7 +117,12 @@
           ${LLVM_BINARY_DIR}/tools/lld/include
           ${LLVM_EXTERNAL_LLD_SOURCE_DIR}/include)
     endif()
-  else()
+
+  # Keep the existing compiler since MSVC-specific flags will be set later.
+  elseif(MSVC)
+  else()
+    # Overriding CMAKE_CXX_COMPILER/CMAKE_C_COMPILER below is sketchy - could
+    # that be removed or reworked instead?
     set(CMAKE_CXX_COMPILER ${LLVM_TOOLS_BINARY_DIR}/clang++)
     set(CMAKE_C_COMPILER ${LLVM_TOOLS_BINARY_DIR}/clang)
   endif()
@@ -109,25 +144,8 @@
     clangToolingCore
     clangRewrite
     clangBasic
-    LLVMProfileData
-    LLVMSupport
-    LLVMMCParser
-    LLVMMC
-    LLVMBitReader
-    LLVMOption
-    LLVMCore)
-
-  if(LLVM_PACKAGE_VERSION VERSION_GREATER "6.0.1")
-    target_link_libraries(hipify-clang PRIVATE clangToolingInclusions)
-  endif()
-
-  if(LLVM_PACKAGE_VERSION VERSION_GREATER "9.0.1")
-    target_link_libraries(hipify-clang PRIVATE LLVMFrontendOpenMP)
-  endif()
-
-  if(LLVM_PACKAGE_VERSION VERSION_EQUAL "15.0.0" OR LLVM_PACKAGE_VERSION VERSION_GREATER "15.0.0")
-    target_link_libraries(hipify-clang PRIVATE LLVMWindowsDriver clangSupport)
-  endif()
+    ${HIPIFY_ADDL_LINK_LIBS}
+  )
 
   if(LLVM_PACKAGE_VERSION VERSION_EQUAL "16.0.0" OR LLVM_PACKAGE_VERSION VERSION_GREATER "16.0.0")
     if(MSVC)
@@ -176,28 +194,36 @@
 
   set(HIPIFY_BIN_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/bin")
 
+  set(HIPIFY_LIBEXEC_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}/hipify")
+
   install(TARGETS hipify-clang DESTINATION bin)
-  # Install bin directory in CMAKE_INSTALL_PREFIX path.
+
   install(
-    DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/bin
-    DESTINATION .
-    PATTERN "hipify-perl"
-    PATTERN "*.sh"
-    PATTERN "findcode.sh" EXCLUDE
-    PATTERN "findcode_headers.sh" EXCLUDE
-    PATTERN "findcode_sources.sh" EXCLUDE
-    PATTERN "findcode_custom.sh" EXCLUDE
-    PATTERN "finduncodep.sh" EXCLUDE)
-
-  set(HIPIFY_LIBEXEC_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}/hipify")
-
-  install(
+    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hipify-perl
     PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/findcode.sh
     PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/findcode_headers.sh
     PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/findcode_sources.sh
     PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/findcode_custom.sh
     PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/finduncodep.sh
+    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hipconvertinplace.sh
+    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hipconvertinplace-perl.sh
+    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hipexamine.sh
+    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hipexamine-perl.sh
     DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/hipify)
+
+  # Adding symlink for hipify-perl for backward compatibility
+  # Note: To be removed once hipify-perl install location usages
+  # are fully updated across modules Or hipify-perl is deprecated.
+  # This backward compatibility Not enabled for Win32 platforms 
+  if( NOT WIN32 )
+    install(
+      CODE "execute_process(
+          COMMAND bash -c \"set -e
+          cd \$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}
+          ln -sf ../${CMAKE_INSTALL_LIBEXECDIR}/hipify/hipify-perl ${CMAKE_INSTALL_BINDIR}/hipify-perl
+          \")")
+  endif()
+
 
   # Headers are already included in HIP SDK, so skip those if including HIPIFY in HIP SDK.
   if( HIPIFY_INSTALL_CLANG_HEADERS)
@@ -239,13 +265,7 @@
     # Get rid of any RPATH definations already.
     set_target_properties(hipify-clang PROPERTIES INSTALL_RPATH "")
     # Set RPATH for the binary.
-    set_target_properties(hipify-clang PROPERTIES LINK_FLAGS "-Wl,--enable-new-dtags -Wl,--rpath,$ORIGIN/../lib" )
-
-    option(FILE_REORG_BACKWARD_COMPATIBILITY "Enable File Reorg with backward compatibility" OFF)
-
-    if(FILE_REORG_BACKWARD_COMPATIBILITY)
-      include(hipify-backward-compat.cmake)
-    endif()
+    set_target_properties(hipify-clang PROPERTIES LINK_FLAGS "-Wl,--enable-new-dtags -Wl,--rpath,\\$ORIGIN/../lib" )
 
     set(CPACK_PACKAGING_INSTALL_PREFIX "/opt/rocm" CACHE PATH "HIP Package Installation Path")
     set(BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR}/packages/hipify-clang)
@@ -308,20 +328,3 @@
   message(STATUS "Initial CUDA to configure:")
   message(STATUS "   - CUDA Toolkit path     : ${CUDA_TOOLKIT_ROOT_DIR}")
   message(STATUS "   - CUDA Samples path     : ${CUDA_SDK_ROOT_DIR}")
-  message(STATUS "   - cuDNN path            : ${CUDA_DNN_ROOT_DIR}")
-  message(STATUS "   - cuTENSOR path         : ${CUDA_TENSOR_ROOT_DIR}")
-  message(STATUS "   - CUB path              : ${CUDA_CUB_ROOT_DIR}")
-
-  if(${CMAKE_VERSION} VERSION_LESS "3.27.0")
-    find_package(CUDA REQUIRED)
-    set(CUDA_VERSION_FULL     "${CUDA_VERSION}")
-  else()
-    find_package(CUDAToolkit REQUIRED)
-    set(CUDA_VERSION_MAJOR    "${CUDAToolkit_VERSION_MAJOR}")
-    set(CUDA_VERSION_MINOR    "${CUDAToolkit_VERSION_MINOR}")
-    set(CUDA_VERSION_PATCH    "${CUDAToolkit_VERSION_PATCH}")
-    set(CUDA_VERSION_FULL     "${CUDAToolkit_VERSION}")
-    set(CUDA_VERSION          "${CUDAToolkit_VERSION_MAJOR}.${CUDAToolkit_VERSION_MINOR}")
-    set(CUDA_TOOLKIT_ROOT_DIR "${CUDAToolkit_LIBRARY_ROOT}")
-  endif()
-

=== docs/sphinx/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.10
# by the following command:
#
#    pip-compile requirements.in
#
accessible-pygments==0.0.5
    # via pydata-sphinx-theme
alabaster==0.7.16
    # via sphinx
asttokens==3.0.0
    # via stack-data
attrs==24.3.0
    # via
    #   jsonschema
    #   jupyter-cache
    #   referencing
babel==2.15.0
    # via
    #   pydata-sphinx-theme
    #   sphinx
beautifulsoup4==4.12.3
    # via pydata-sphinx-theme
breathe==4.35.0
    # via rocm-docs-core
certifi==2024.7.4
    # via requests
cffi==1.16.0
    # via
    #   cryptography
    #   pynacl
charset-normalizer==3.3.2
    # via requests
click==8.1.7
    # via
    #   jupyter-cache
    #   sphinx-external-toc
comm==0.2.2
    # via ipykernel
cryptography==44.0.1
    # via pyjwt
debugpy==1.8.12
    # via ipykernel
decorator==5.1.1
    # via ipython
deprecated==1.2.14
    # via pygithub
docutils==0.21.2
    # via
    #   breathe
    #   myst-parser
    #   pydata-sphinx-theme
    #   sphinx
exceptiongroup==1.2.2
    # via ipython
executing==2.1.0
    # via stack-data
fastjsonschema==2.19.1
    # via
    #   nbformat
    #   rocm-docs-core
gitdb==4.0.11
    # via gitpython
gitpython==3.1.43
    # via rocm-docs-core
greenlet==3.1.1
    # via sqlalchemy
idna==3.7
    # via requests
imagesize==1.4.1
    # via sphinx
importlib-metadata==8.6.1
    # via
    #   jupyter-cache
    #   myst-nb
ipykernel==6.29.5
    # via myst-nb
ipython==8.31.0
    # via
    #   ipykernel
    #   myst-nb
jedi==0.19.2
    # via ipython
jinja2==3.1.6
    # via
    #   myst-parser
    #   sphinx
jsonschema==4.23.0
    # via nbformat
jsonschema-specifications==2024.10.1
    # via jsonschema
jupyter-cache==1.0.1
    # via myst-nb
jupyter-client==8.6.3
    # via
    #   ipykernel
    #   nbclient
jupyter-core==5.7.2
    # via
    #   ipykernel
    #   jupyter-client
    #   nbclient
    #   nbformat
markdown-it-py==3.0.0
    # via
    #   mdit-py-plugins
    #   myst-parser
markupsafe==2.1.5
    # via jinja2
matplotlib-inline==0.1.7
    # via
    #   ipykernel
    #   ipython
mdit-py-plugins==0.4.1
    # via myst-parser
mdurl==0.1.2
    # via markdown-it-py
myst-nb==1.1.2
    # via rocm-docs-core
myst-parser==3.0.1
    # via myst-nb
nbclient==0.10.2
    # via
    #   jupyter-cache
    #   myst-nb
nbformat==5.10.4
    # via
    #   jupyter-cache
    #   myst-nb
    #   nbclient
nest-asyncio==1.6.0
    # via ipykernel
packaging==24.0
    # via
    #   ipykernel
    #   sphinx
parso==0.8.4
    # via jedi
pexpect==4.9.0
    # via ipython
platformdirs==4.3.6
    # via jupyter-core
prompt-toolkit==3.0.50
    # via ipython
psutil==6.1.1
    # via ipykernel
ptyprocess==0.7.0
    # via pexpect
pure-eval==0.2.3
    # via stack-data
pycparser==2.22
    # via cffi
pydata-sphinx-theme==0.16.1
    # via
    #   rocm-docs-core
    #   sphinx-book-theme
pygithub==2.3.0
    # via rocm-docs-core
pygments==2.18.0
    # via
    #   accessible-pygments
    #   ipython
    #   pydata-sphinx-theme
    #   sphinx
pyjwt[crypto]==2.8.0
    # via pygithub
pynacl==1.5.0
    # via pygithub
python-dateutil==2.9.0.post0
    # via jupyter-client
pyyaml==6.0.1
    # via
    #   jupyter-cache
    #   myst-nb
    #   myst-parser
    #   rocm-docs-core
    #   sphinx-external-toc
pyzmq==26.2.0
    # via
    #   ipykernel
    #   jupyter-client
referencing==0.36.1
    # via
    #   jsonschema
    #   jsonschema-specifications
requests==2.32.4
    # via
    #   pygithub
    #   sphinx
rocm-docs-core==1.21.1
    # via -r requirements.in
rpds-py==0.22.3
    # via
    #   jsonschema
    #   referencing
six==1.17.0
    # via python-dateutil
smmap==5.0.1
    # via gitdb
snowballstemmer==2.2.0
    # via sphinx
soupsieve==2.5
    # via beautifulsoup4
sphinx==7.3.7
    # via
    #   breathe
    #   myst-nb
    #   myst-parser
    #   pydata-sphinx-theme
    #   rocm-docs-core
    #   sphinx-book-theme
    #   sphinx-copybutton
    #   sphinx-design
    #   sphinx-external-toc
    #   sphinx-notfound-page
sphinx-book-theme==1.1.2
    # via rocm-docs-core
sphinx-copybutton==0.5.2
    # via rocm-docs-core
sphinx-design==0.5.0
    # via rocm-docs-core
sphinx-external-toc==1.0.1
    # via rocm-docs-core
sphinx-notfound-page==1.0.1
    # via rocm-docs-core
sphinxcontrib-applehelp==1.0.8
    # via sphinx
sphinxcontrib-devhelp==1.0.6
    # via sphinx
sphinxcontrib-htmlhelp==2.0.5
    # via sphinx
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-qthelp==1.0.7
    # via sphinx
sphinxcontrib-serializinghtml==1.1.10
    # via sphinx
sqlalchemy==2.0.37
    # via jupyter-cache
stack-data==0.6.3
    # via ipython
tabulate==0.9.0
    # via jupyter-cache
tomli==2.0.1
    # via sphinx
tornado==6.5.1
    # via
    #   ipykernel
    #   jupyter-client
traitlets==5.14.3
    # via
    #   comm
    #   ipykernel
    #   ipython
    #   jupyter-client
    #   jupyter-core
    #   matplotlib-inline
    #   nbclient
    #   nbformat
typing-extensions==4.11.0
    # via
    #   ipython
    #   myst-nb
    #   pydata-sphinx-theme
    #   pygithub
    #   referencing
    #   sqlalchemy
urllib3==2.5.0
    # via
    #   pygithub
    #   requests
wcwidth==0.2.13
    # via prompt-toolkit
wrapt==1.16.0
    # via deprecated
zipp==3.21.0
    # via importlib-metadata

=== debian/changelog ===
hipify (7.0.2+dfsg-1) unstable; urgency=medium

  * New upstream version 7.0.2+dfsg
  * Upload to unstable
  * Update Build-Depends from LLVM 20 to LLVM 21
  * Update d/gbp.conf to follow DEP-14

 -- Cordell Bloor <cgmb@debian.org>  Fri, 17 Oct 2025 18:55:24 -0600

=== debian/control ===
--- 
+++ 
@@ -9,11 +9,11 @@
 Uploaders: Cordell Bloor <cgmb@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- clang-20,
+ clang-21,
  cmake,
- libclang-20-dev,
+ libclang-21-dev,
  libzstd-dev,
- llvm-20-dev,
+ llvm-21-dev,
  zlib1g-dev,
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f
export VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Scmake

override_dh_auto_install:
	dh_auto_install
	sed -i 's@#!/usr/bin/env perl@#!/usr/bin/perl@' ./debian/tmp/usr/bin/hipify-perl

# dwz does not support DWARF-5
override_dh_dwz:
	:

=== debian/watch ===
Version: 5

Source: https://github.com/rocm/hipify/tags
Matching-Pattern: (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz
Dversionmangle: s/\+dfsg//
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hipify-$1.tar.gz%
Oversionmangle: s/(.*)/$1+dfsg/

## hipify 7.1.0+dfsg

=== debian/changelog ===
hipify (7.1.0+dfsg-0ubuntu3) resolute; urgency=medium

  * Revert to LLVM 21 toolchain (from ROCm LLVM fork)
    - d/control: revert build-depends to llvm-toolchain-21
    - d/rules: remove ROCm-specific CMake configuration and shlibdeps override
    - d/p/remove-redundant-target_link_libraries.patch: restore patch
    - d/p/fix-monolithic-clang-cpp-and-rpath.patch: drop ROCm patch
    - d/p/use-system-clang-resource-directory.patch: revert to LLVM 21 paths

 -- Igor Luppi <igor.luppi@canonical.com>  Mon, 20 Jan 2026 00:00:00 +0000

hipify (7.1.0+dfsg-0ubuntu2) resolute; urgency=medium

  * d/control: fix missing runtime dependency
    - adding clang-rocm as depends for bin:hipify-clang
  * d/t/hipify: remove unnecessary flag for autopkgtest

 -- Igor Luppi <igor.luppi@canonical.com>  Thu, 11 Dec 2025 15:53:16 -0300

hipify (7.1.0+dfsg-0ubuntu1) resolute; urgency=medium

  * chore: New upstream version 7.1.0
  * d/rules: explicitly point CMake to ROCm configuration
  * d/rules: fix shlibdeps lookup for private ROCm libraries
  * d/rules: optimize linker flags for binary size and dependencies
  * d/control: update build-depends for ROCm LLVM toolchain
  * d/p/remove-redundant-target_link_libraries.patch: drop patch
  * d/p/fix-monolithic-clang-cpp-and-rpath.patch: new patch to fix clang link
    with llvm-toolchain-rocm.
  * d/p/use-system-clang-resource-directory.patch: update clang path for ROCm
  * d/t/{control,hipify}: include autopkgtests for hipify-{clang,perl}

 -- Igor Luppi <igor.luppi@canonical.com>  Thu, 27 Nov 2025 18:30:17 -0300

=== debian/control ===
--- 
+++ 
@@ -5,11 +5,15 @@
 Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/rocm-team/hipify.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/hipify
-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
 Uploaders: Cordell Bloor <cgmb@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  clang-21,
+ clang-tools-21,
+ clang-format-21,
+ clang-tidy-21,
  cmake,
  libclang-21-dev,
  libzstd-dev,
@@ -22,6 +26,7 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
+         libclang-common-21-dev,
 Recommends: nvidia-cuda-toolkit
 Description: CUDA to HIP source-to-source translation tool
  hipify-clang is a tool that converts CUDA sources to HIP. It is built on

=== debian/tests/control ===
Tests: hipify
Depends: hipify-clang, hipify-perl, nvidia-cuda-toolkit
Restrictions: allow-stderr
